VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSettings"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
' (c) 2002 by Jochen Wierum
' Diese Klasse diente einmal als Beispiel, wie eine Klasse funktioniert

Option Explicit

' ###################### Global #########################################
    Private m_EditMode As Integer
    Private m_WriteIfNA As Boolean
    
    ' Registry:
    Private m_REGHKEY As HKEYS
    Private m_REGPath As String
    
    ' INI:
    Private m_INIFile As String
    Private m_INIMaxLoadToRAM As Long
' ###################### INI ##############################################
    Private Type SettingPair
      ValName As String
      Value As String
    End Type
    
    Private Type Setting
      Title As String
      Sets() As SettingPair
    End Type
    
    Private m_INISettings() As Setting
' ###################### REGISTRY #########################################
    Private Const REG_SZ = 1
    
    ' Fr Leute, denen ein einfaches "Speichern"
    ' von Daten nicht reicht
    Public Enum HKEYS
      HKEY_CURRENT_USER = &H80000001
      HKEY_LOCAL_MACHINE = &H80000002
    End Enum
    
    Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal Reserved As Long, ByVal samDesired As Long, phkResult As Long) As Long
    Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
    Private Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal Reserved As Long, ByVal lpClass As String, ByVal dwOptions As Long, ByVal samDesired As Long, lpSecurityAttributes As Any, phkResult As Long, lpdwDisposition As Long) As Long
    Private Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long
    Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
    Private Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Any, ByVal cbData As Long) As Long
    Private Declare Function RegEnumKeyEx Lib "advapi32.dll" Alias "RegEnumKeyExA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, lpcbName As Long, ByVal lpReserved As Long, ByVal lpClass As String, lpcbClass As Long, lpftLastWriteTime As Any) As Long
    Private Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, lpcbValueName As Long, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
    Private Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
' #########################################################################

' Liet einen beliebigen REG_SZ Wert aus der Registry aus
Private Function GetRegValue(ByVal hKey As HKEYS, ByVal Path As String, ByVal ValName As String, ByVal Default As Variant) As Variant
  Dim Result As Long
  Dim ValType As Long
  Dim strBuf As String
  Dim BufSize As Long
  Dim Key As Long
  
  ' Falls wir nichts finden, nehmen wir den Standartwert.
  GetRegValue = Default
  
  ' Schlssel ffnen
  RegOpenKeyEx hKey, Path, 0, &HF003F, Key
  If Key <> 0 Then
    
    ' Jetzt holen wir uns Infos ber den Wert
    Result = RegQueryValueEx(Key, ValName, 0, ValType, ByVal 0, BufSize)
    
    ' Wenn er existiert und vom Typ REG_SZ ist (was anderes brauchen wir nicht)
    If Result = 0 And ValType = REG_SZ Then
      
      ' Wert einlesen
      strBuf = String(BufSize, Chr$(0))
      Result = RegQueryValueEx(Key, ValName, 0, 0, ByVal strBuf, BufSize)
      
      ' Nullterminiertungszeichen abschneiden
      If Result = 0 Then
        GetRegValue = Left$(strBuf, InStr(1, strBuf, Chr$(0)) - 1)
      End If
    End If
    
    ' Schlssel wieder schlieen
    RegCloseKey Key
  End If
End Function

' Einen Wert in die Registry schreiben
Private Function SetRegValue(ByVal hResult As HKEYS, ByVal Path As String, ByVal ValName As String, ByVal Value As String) As Boolean
  Dim Result As Long
  Dim Key As Long
  
  ' ffnen, wenn nicht existiert, erstellen
  RegCreateKeyEx hResult, Path, 0, "REG_DWORD", 0, &HF003F, ByVal 0&, Key, Result
  
  ' Wenn alles geklappt hat
  If Result <> 0 Then
    
    ' Wert schreiben, wenn Result = 0 ist alles in Ordnung
    Result = RegSetValueEx(Key, ValName, 0, REG_SZ, ByVal Value, Len(Value))
    SetRegValue = (Result = 0)
    
    ' Und wieder schlieen
    RegCloseKey Key
  End If
End Function

' Lscht einen Eintrag aus der Registry
Private Function DelRegValue(ByVal hKey As HKEYS, ByVal Path As String, ByVal ValName As String) As Boolean
  Dim Key As Long
  Dim Result As Long
  
  ' Zweig ffnen/erstellen
  RegCreateKeyEx hKey, Path, 0, "REG_DWORD", 0, &HF003F, ByVal 0&, Result, Key
  
  ' Es hat geklappt
  If Key <> 0 Then
    
    ' Wenn der Wert nicht existiert, liefert diese Routine
    ' den Wert False, obwohl der Wert danach immer noch nicht
    ' existiert. Dies knnte eine Fehlerbehandlungsroutine
    ' stren, daher legen wir den Wert erst an, um ihn dann
    ' zu lschen. Dann gibt es keine Fehler...
    SetRegValue hKey, Path, ValName, "del"
    
    ' Jetzt aber lschen.
    DelRegValue = (RegDeleteValue(Result, ValName) = 0)
    
    ' Wenn es keinen Unterzweig und keinen weiteren Wert gibt,
    ' lschen wir unseren Zweig gleich.
    ' Das hilft nicht sehr, aber ein wenig trgt es dazu bei, dass
    ' die Registry sauber bleibt.
    If RegEnumKeyEx(Result, 0, ByVal 0&, Key, ByVal 0&, vbNullString, ByVal 0&, ByVal 0&) = 259& And _
       RegEnumValue(Result, 0, ByVal 0&, Key, 0, ByVal 0&, ByVal 0&, ByVal 0&) = 259& Then _
       RegDeleteKey Result, ""
    
    ' Und alles wieder schlieen
    RegCloseKey Result
  End If
End Function

' Einen Wert aus einer INI Datei lesen
Private Function GetIniValue(ByVal File As String, ByVal Section As String, ByVal ValName As String, ByVal Default As Variant) As Variant
  Dim temp As String
  Dim actSection As String
  Dim ff As Integer
  
  On Error GoTo ErrOut
  
  ' Auch hier wird erst der Standartwert gesetzt
  GetIniValue = Default
  
  ff = FreeFile
  Open File For Input As #ff
  Do Until EOF(ff)
    
    ' Die Datei wird Zeilenweise gelesen
    Line Input #ff, temp
    If Len(temp) > 2 Then
      
      ' Oh, eine neue Sektion.
      If Left(temp, 1) = "[" Then
        actSection = Mid(temp, 2, Len(temp) - 2)
        
      ' Ein weiterer Eintrag.
      Else
        
        ' Sind wir berhaupt in der Richtigen Sektion?
        If LCase(Section) = LCase(actSection) Then
          
          ' Wenn der Wert passt, geben wir ihn zurck.
          If LCase(Left(temp, InStr(temp, "=") - 1)) = LCase(ValName) Then
            GetIniValue = Mid(temp, InStr(temp, "=") + 1)
            
            ' Aussteigen.
            GoTo ErrOut
          End If
        End If
      End If
    End If
  Loop
ErrOut:
  ' Wir wollen ja keinen Mll hinterlassen.
  If ff <> 0 Then Close #ff
End Function

' Einen Wert in eine INI Datei schreiben.
Private Function SetIniValue(ByVal File As String, ByVal Section As String, ByVal ValName As String, ByVal Value As Variant) As Boolean
  Dim ff As Integer
  Dim ff2 As Integer
  Dim written As Boolean
  Dim temp As String
  Dim actSection As String
  
  On Error GoTo ErrOut
  
  ff = FreeFile
  
  ' Wir brauchen eine temporre Datei
  Open File & ".tmp" For Output As #ff
  
  ' Wenn das original schon existiert...
  If Len(Dir(File)) > 0 Then
    ff2 = FreeFile
    
    ' ...ffnen.
    Open File For Input As #ff2
    Do Until EOF(ff2)
      Line Input #ff2, temp
      If Len(temp) > 0 Then
        
        ' Sind wir in einer neuen Rubrik?
        If Left(temp, 1) = "[" Then
          
          ' Prfen, ob das unsere Rubrik WAR.
          If LCase(actSection) = LCase(Section) Then
          
            ' Wenn wir noch nicht geschrieben haben, existiert
            ' der Wert noch nicht.
            If Not written Then Print #ff, ValName & "=" & Value
            written = True
          End If
          
          ' Den neuen Wert speichern
          actSection = Mid(temp, 2, Len(temp) - 2)
          
          ' ...und weiter kopieren...
          Print #ff, temp
          
        ' Nein, es ist ein Eintrag.
        Else
          
          ' Sind wir in der richtigen Rubrik?
          If LCase(actSection) = LCase(Section) Then
            
            ' Ist das unser Wert?
            If LCase(Left(temp, InStr(temp, "=") - 1)) = LCase(ValName) Then
              
              ' Ja? Dann schreiben wir den Neuen rein.
              Print #ff, ValName & "=" & Value
              written = True
              
            Else
              
              ' Sachade. Weiterkopieren.
              Print #ff, temp
            End If
          Else
            
            ' Falsche Rubrik. Kopieren.
            Print #ff, temp
          End If
        End If
      End If
    Loop
    
    ' Schlieen.
    Close #ff2
    ff2 = 0
  End If
  
  ' Wenn die Rubrik nicht existiert, wurde auch nichts geschrieben.
  ' Wir hngen die neue Sektion hinten dran.
  If Not written Then
    
    ' Diese berprfung findet erst vor der nchsten Sektion statt.
    ' Wenn diese aber die letzte ist, mssen wir dies hier
    ' nachholen.
    If LCase(Section) = LCase(actSection) Then
      Print #ff, ValName & "=" & Value
    Else
      Print #ff, "[" & Section & "]"
      Print #ff, ValName & "=" & Value
    End If
  End If
  
  ' so weit so gut, nun auch die neue Datei speichern
  Close #ff
  ff = 0
  
  ' Die alte lschen und durch die neue ersetzen
  If Len(Dir(File)) > 0 Then Kill File
  Name File & ".tmp" As File
  
  ' Fertig.
  SetIniValue = True
ErrOut:
  If ff <> 0 Then Close #ff
  If ff2 <> 0 Then Close #ff2
End Function

' Einen Wert aus einer INI Datei lschen
Private Function DelIniValue(ByVal File As String, ByVal Section As String, ByVal ValName As String) As Boolean
  Dim ff As Integer
  Dim ff2 As Integer
  Dim temp As String
  Dim actSection As String
  
  On Error GoTo ErrOut
  
  ff = FreeFile
  
  ' Auch hier brauchen wir zunchst eine 2. Datei
  Open File & ".tmp" For Output As #ff
  
  ' Wenn das Original schon existiert, ffnen.
  If Len(Dir(File)) > 0 Then
    ff2 = FreeFile
    Open File For Input As #ff2
    Do Until EOF(ff2)
      
      ' Zeilenweise einlesen
      Line Input #ff2, temp
      If Len(temp) > 0 Then
      
        ' Achtung. Sektionswechsel
        If Left(temp, 1) = "[" Then
          actSection = Mid(temp, 2, Len(temp) - 2)
          Print #ff, temp
        
        ' Nur ein normaler Eintrag
        Else
          
          ' Sind wir in der richtigen Sektion?
          If LCase(actSection) = LCase(Section) Then
            
            ' Muss der Wert NICHT dran glauben? Dann kopieren.
            If LCase(Left(temp, InStr(temp, "=") - 1)) <> LCase(ValName) Then
              Print #ff, temp
            End If
          Else
            
            ' Falsche Sektion.
            Print #ff, temp
          End If
        End If
      End If
    Loop
    
    ' Schlieen
    Close #ff2
    ff2 = 0
  End If
  
  ' Speichern
  Close #ff
  ff = 0
  
  ' Ersetzen
  If Len(Dir(File)) > 0 Then Kill File
  Name File & ".tmp" As File
  
  ' Ende
  DelIniValue = True
ErrOut:
  If ff <> 0 Then Close #ff
  If ff2 <> 0 Then Close #ff2
End Function

' Einen INI Eintrag im Speicher lesen
Private Function GetRAMIniValue(ByRef Settings() As Setting, ByVal Section As String, ByVal ValName As String, ByVal Default As Variant) As Variant
  Dim i As Integer
  Dim j As Integer
  
  On Error GoTo ErrOut
  
  GetRAMIniValue = Default
  
  ' Alle Eintrge durchgehen
  For i = 0 To UBound(Settings)
    If LCase(Settings(i).Title) = LCase(Section) Then
      For j = 0 To UBound(Settings(i).Sets)
        
        ' Stimmt der Name?
        If LCase(Settings(i).Sets(j).ValName) = LCase(ValName) Then
          
          ' Wert kopieren.
          GetRAMIniValue = Settings(i).Sets(j).Value
          Exit Function
        End If
      Next j
      Exit Function
    End If
  Next i
  
ErrOut:
End Function

' Einen INI Wert im Speicher ablegen
Private Function SetRAMIniValue(ByRef Settings() As Setting, ByVal Section As String, ByVal ValName As String, ByVal Value As Variant) As Boolean
  Dim i As Integer
  Dim j As Integer
  
  On Error GoTo ErrOut
  
  ' Wieder alles Durchsuchen
  For i = 0 To UBound(Settings)
    
    ' Wenn die Sektion stimmt
    If LCase(Settings(i).Title) = LCase(Section) Then
      
      ' Nach dem Wert suchen.
      For j = 0 To UBound(Settings(i).Sets)
        If LCase(Settings(i).Sets(j).ValName) = LCase(ValName) Then
          
          ' Gefunden. ndern.
          Settings(i).Sets(j).Value = Value
          SetRAMIniValue = True
          Exit Function
        End If
      Next j
      
      ' Nicht gefunden? Dann hinzufgen.
      If Len(Settings(i).Sets(0).ValName) > 0 Then ReDim Preserve Settings(i).Sets(UBound(Settings(i).Sets) + 1)
      With Settings(i).Sets(UBound(Settings(i).Sets))
        .ValName = ValName
        .Value = Value
      End With
      
      ' Aussteigen.
      SetRAMIniValue = True
      Exit Function
    End If
  Next i
  
  ' Falls die Rubrik fehlt, diese anlegen
  i = UBound(Settings)
  If Len(Settings(i).Title) > 0 Then ReDim Preserve Settings(i + 1)
  With Settings(UBound(Settings))
    .Title = Section
    ReDim .Sets(0)
    With .Sets(0)
      .ValName = ValName
      .Value = Value
    End With
  End With
  
  SetRAMIniValue = True
ErrOut:
End Function

' Einen Wert aus dem Speicher lschen
Private Function DelRAMIniValue(ByRef Settings() As Setting, ByVal Section As String, ByVal ValName As String) As Boolean
  Dim i As Integer
  Dim j As Integer
  Dim k As Integer
  
  On Error GoTo ErrOut
  
  ' Mal wieder alles durchsuchen
  For i = 0 To UBound(Settings)
    
    ' Sektion stimmt...
    If LCase(Settings(i).Title) = LCase(Section) Then
      For j = 0 To UBound(Settings(i).Sets)
        
        ' ...der Name auch?
        If LCase(Settings(i).Sets(j).ValName) = LCase(ValName) Then
          
          ' Dann mit dem nchsten berschreiben;
          ' am Ende das Array verkleinern
          ' Man knnte auch Collections nehmen, aber
          ' das wre langsammer.
          If UBound(Settings(i).Sets) > 0 Then
            For k = j To UBound(Settings(i).Sets) - 1
              Settings(i).Sets(k) = Settings(i).Sets(k + 1)
            Next k
            ReDim Preserve Settings(i).Sets(k - 1)
            
          ' Das war der letzte Einrag.
          ' Das heit, die Rubrik wird nicht mehr gebraucht
          Else
            For k = i To UBound(Settings) - 1
              Settings(k) = Settings(k + 1)
            Next k
            ReDim Preserve Settings(k - 1)
          End If
          
          ' Erfolgreich
          DelRAMIniValue = True
          Exit Function
        End If
      Next j
    End If
  Next i
  
  ' Auch erfolgreich. Selbst wenn der Wert nie existierte,
  ' jetzt ist er weg ;-)
  DelRAMIniValue = True
ErrOut:
End Function

' Alles auf die Standartwerte setzen, speichern der INIs im
' RAM erzwingen.
' Vorsicht. Danach ist noch eine Initilisierung ntig.
' Diese Sub wird nur gebraucht, wenn man explizit eine INI
' Datei speichern will. Dies wird beim Entladen der Klasse auch
' automatisch gemacht.
Private Function ReInitialise() As Boolean
  ReInitialise = True
  
  ' Abfangen, ob beim Speichern der INI Datei etwas schief geht
  If m_EditMode = 2 Then ReInitialise = SaveRAMIni(m_INIFile, m_INISettings)
  
  m_EditMode = 0
    
  ReDim m_INISettings(0)
  ReDim m_INISettings(0).Sets(0)
End Function

' Hier gibt' s nichts zu sagen.
Private Sub Class_Initialize()
  ReInitialise
End Sub

' Die Klasse soll dazu genutzt werden,
' um in die Registrierung zu schreiben
Public Function InitialiseREGISTRY(Optional ByVal hKey As HKEYS, Optional ByVal Path As String = "") As Boolean
  On Error GoTo ErrOut
  
  ReInitialise
  
  ' Standartwerte fr den Key setzen, falls nicht schon gesetzt
  If hKey = 0 Then hKey = HKEY_CURRENT_USER
  m_REGHKEY = hKey
  
  ' Falls kein Pfad eingegeben wurde, einen mglichst aus-
  ' fhrlichen erstellen
  If Len(App.CompanyName) > 0 Then
    If Len(Path) = "0" Then Path = "SOFTWARE\" & App.CompanyName & "\" & App.Title & "\"
  Else
    If Len(Path) = "0" Then Path = "SOFTWARE\" & App.Title & "\"
  End If
  
  ' Noch ein "\" dranhngen und speichern.
  If Right(Path, 1) <> "\" Then Path = Path & "\"
  m_REGPath = Path
  
  ' Wir arbeiten in der Registry
  m_EditMode = 1
  
  InitialiseREGISTRY = True
ErrOut:
End Function

Public Function InitialiseINI(Optional ByVal File As String, Optional ByVal MaxLoadIntoRAM As Long = 524288)
  On Error GoTo ErrOut
  
  ReInitialise
  
  ' Standartwerte setzen und speichern
  If Len(File) = 0 Then File = App.Path & IIf(Right(App.Path, 1) = "\", "", "\") & "settings.ini"
  If Mid(File, 2, 2) <> ":\" Then File = App.Path & IIf(Right(App.Path, 1) = "\", "", "\") & File
  m_INIFile = File
  
  ' Ist unsere Datei so klein, dass man sie in den RAM laden kann?
  m_INIMaxLoadToRAM = MaxLoadIntoRAM
  If Len(Dir(File)) > 0 Then
    If FileLen(File) <= MaxLoadIntoRAM Then
      ' Ja, laden.
      m_EditMode = 2
      InitialiseINI = LoadRAMIni(File, m_INISettings)
      Exit Function
    Else
      ' Nein, wir verwenden andere Routinen.
      m_EditMode = 3
    End If
  Else
    ' Die Datei existiert gar nicht.
    If MaxLoadIntoRAM > -1 Then m_EditMode = 2 Else m_EditMode = 3
  End If
  
  InitialiseINI = True
ErrOut:
End Function

' Eine INI Datei in den Speicher laden
Private Function LoadRAMIni(ByVal File As String, ByRef Settings() As Setting) As Boolean
  Dim ff As Integer
  Dim temp As String
  Dim actSetting As Integer
  
  On Error GoTo ErrOut
  
  ' Gibt es die Datei?
  If Len(Dir(File)) > 0 Then
    ff = FreeFile
    Open File For Input As #ff
    Do Until EOF(ff)
      
      ' Zeilenweise lesen
      Line Input #ff, temp
      If Len(temp) > 0 Then
        
        ' Neue Sektion? Array erweitern.
        If Left(temp, 1) = "[" Then
          temp = Mid(temp, 2, Len(temp) - 2)
          
          ' Nur, wenn Element 0 noch nicht belegt ist.
          If Len(Settings(actSetting).Title) > 0 Then ReDim Preserve Settings(UBound(Settings()) + 1)
          actSetting = UBound(Settings)
          With Settings(actSetting)
            .Title = temp
            ReDim .Sets(0)
          End With
        
        ' Neuer Wert? 2. Array erweitern.
        Else
          ' Wenn das 1. Element nicht doch noch frei ist.
          If Len(Settings(actSetting).Sets(0).ValName) > 0 Then ReDim Preserve Settings(actSetting).Sets(UBound(Settings(actSetting).Sets) + 1)
          With Settings(actSetting).Sets(UBound(Settings(actSetting).Sets))
            .ValName = Left(temp, InStr(temp, "=") - 1)
            .Value = Mid(temp, InStr(temp, "=") + 1)
          End With
        End If
      End If
    Loop
  End If
  
  LoadRAMIni = True
ErrOut:
  If ff <> 0 Then Close #ff
End Function

' Die Werte im Speicher in eine File schreiben.
Private Function SaveRAMIni(ByVal File As String, ByRef Settings() As Setting) As Boolean
  Dim ff As Integer
  ' Dim actSection As String
  Dim i As Integer
  Dim j As Integer
  
  On Error GoTo ErrOut
  
  ff = FreeFile
  
  ' ffnen
  Open File For Output As #ff
  For i = 0 To UBound(Settings)
    
    ' Wenn was drinn steht, speichern.
    With Settings(i)
    If Len(.Title) > 0 Then
      
      ' Der Titel
      Print #ff, vbCrLf & "[" & .Title & "]"
      
      ' Die Werte
      For j = 0 To UBound(.Sets)
        Print #ff, .Sets(j).ValName & "=" & .Sets(j).Value
      Next j
    End If
    End With
  Next i
  
  SaveRAMIni = True
ErrOut:
  If ff <> 0 Then Close #ff
End Function

' Da will jemand einen Wert auslesen.
Public Function GetSetting(ByVal Section As String, ByVal SettingName As String, Optional ByVal Default As Variant) As Variant
  
  ' Haben wir alles, was wir brauchen?
  If m_EditMode = 0 Or Len(Section) = 0 Or Len(SettingName) = 0 Then Exit Function
  
  ' Je nachdem, wie wir arbeiten an die unterschiedlichen Subs
  ' weitergeben und den Rckgabewert zurckgeben
  If m_EditMode = 1 Then
    GetSetting = GetRegValue(m_REGHKEY, m_REGPath & Section, SettingName, Default)
  ElseIf m_EditMode = 2 Then
    GetSetting = GetRAMIniValue(m_INISettings, Section, SettingName, Default)
  ElseIf m_EditMode = 3 Then
    GetSetting = GetIniValue(m_INIFile, Section, SettingName, Default)
  End If
  
  ' Wenn der Standartwert zurckgegeben wurde, knnte es sein, dass
  ' der Wert gar nicht existiert. WriteIfNA schreibt ihn aber, wenn
  ' er fehlt. Also prfen wir zuerst, ob er geschrieben werden soll.
  If GetSetting = Default And m_WriteIfNA Then
    
    ' tatschlich. Aber hier hier haben wir es einfach. Wir starten
    ' die SetSetting Sub mit den gleichen Parametern, wie hier.
    SetSetting Section, SettingName, Default
  End If
End Function

'  Speichern
Public Function SetSetting(ByVal Section As String, ByVal SettingName As String, ByVal Value As Variant) As Boolean
  
  ' Ist wieder alles dabei?
  If m_EditMode = 0 Or Len(Section) = 0 Or Len(SettingName) = 0 Or Len(Value) = 0 Then Exit Function
  
  ' Weil bei Boolean nicht "Falsch" dastehen soll, machen
  ' wir eine Zahl draus...
  If VarType(Value) = vbBoolean Then Value = Int(Value)
  
  ' Und wieder weiterleiten
  If m_EditMode = 1 Then
    SetSetting = SetRegValue(m_REGHKEY, m_REGPath & Section, SettingName, Value)
  ElseIf m_EditMode = 2 Then
    SetSetting = SetRAMIniValue(m_INISettings, Section, SettingName, Value)
  ElseIf m_EditMode = 3 Then
    SetSetting = SetIniValue(m_INIFile, Section, SettingName, Value)
  End If
End Function

' Zu guter Letzt, das Lschen
Public Function DeleteSetting(ByVal Section As String, ByVal SettingName As String) As Boolean
  
  ' Alle Mann da?
  If m_EditMode = 0 Or Len(Section) = 0 Or Len(SettingName) = 0 Then Exit Function
  
  ' Weiterleiten
  If m_EditMode = 1 Then
    DeleteSetting = DelRegValue(m_REGHKEY, m_REGPath & Section, SettingName)
  ElseIf m_EditMode = 2 Then
    DeleteSetting = DelRAMIniValue(m_INISettings, Section, SettingName)
  ElseIf m_EditMode = 3 Then
    DeleteSetting = DelIniValue(m_INIFile, Section, SettingName)
  End If
End Function

Private Sub Class_Terminate()
  ' Die Klasse wird entladen; speichern
  ReInitialise
  Erase m_INISettings
End Sub

Public Property Let WriteIfNA(newValue As Boolean)
    m_WriteIfNA = newValue
End Property

Public Property Get WriteIfNA() As Boolean
    WriteIfNA = m_WriteIfNA
End Property
