VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsTree"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' (c) 2004 - 2005 by Jochen Wierum
' diese Klasse kann auf sich selbst verweisen, es knnen also durchaus
' komplexe Baumstrukturen dargestellt werden
'
' 1
' |->2
' |  |->3
' |  |  |->4
' |  |->5
' |
' |->6
' |  |->7
' |
' |->8

Option Explicit

Private m_cmdTreeName As String
Private m_cmds() As clsCommand
Private m_cmdSubTrees() As clsTree

' Zweigname
Public Sub SetTreeName(TreeName As String)
    m_cmdTreeName = TreeName
End Sub

Public Function GetTreeName() As String
    GetTreeName = m_cmdTreeName
End Function

' Kommando einfgen
Public Function AddCommand(CmdName As String) As clsCommand
    Dim i As Long
    
    ' Existiert schon?
    For i = 1 To UBound(m_cmds)
        If m_cmds(i).GetCmdName = CmdName Then
            Set AddCommand = m_cmds(i)
            Exit Function
        End If
    Next i
    
    ' Anlegen
    ReDim Preserve m_cmds(i)
    Set m_cmds(i) = New clsCommand
    m_cmds(i).SetCmdName CmdName
    Set AddCommand = m_cmds(i)
End Function

' Legt einen unterzweig an, gibt zurck, ob er bereits existierte
Public Function SubTree(TreeName As String, Optional created As Boolean) As clsTree
    Dim i As Long
    
    ' Existiert schon
    created = False
    For i = 1 To UBound(m_cmdSubTrees)
        If m_cmdSubTrees(i).GetTreeName = TreeName Then
            Set SubTree = m_cmdSubTrees(i)
            Exit Function
        End If
    Next i
    
    ' Anlegen
    created = True
    ReDim Preserve m_cmdSubTrees(i)
    Set m_cmdSubTrees(i) = New clsTree
    m_cmdSubTrees(i).SetTreeName TreeName
    Set SubTree = m_cmdSubTrees(i)
End Function

' Klasse wird entladen, alles vernichten und entladen
Private Sub Class_Terminate()
    Dim i As Integer
    
    For i = 1 To UBound(m_cmdSubTrees)
        Set m_cmdSubTrees(i) = Nothing
    Next i
    Erase m_cmdSubTrees
    
    For i = 1 To UBound(m_cmds)
        Set m_cmds(i) = Nothing
    Next i
    Erase m_cmds
End Sub

' Variablen initialisieren
Private Sub Class_Initialize()
    ReDim m_cmds(0)
    ReDim m_cmdSubTrees(0)
End Sub

' ohne weitere Worte
Public Function GetCommandCount() As Long
    GetCommandCount = UBound(m_cmds)
End Function

' Befehl anhand von ID herausfinden
Public Function GetCommand(CNr As Long) As clsCommand
    If CNr < 0 Or CNr > UBound(m_cmds) Then Exit Function
    
    Set GetCommand = m_cmds(CNr)
End Function

' ohne weitere Worte
Public Function GetSubTreeCount() As Long
    GetSubTreeCount = UBound(m_cmdSubTrees)
End Function

' Subtree anhand von ID ermitteln
Public Function GetSubTree(TNr As Long) As clsTree
    If TNr < 0 Or TNr > UBound(m_cmdSubTrees) Then Exit Function
    
    Set GetSubTree = m_cmdSubTrees(TNr)
End Function
