Attribute VB_Name = "modHidden"
' (c) 2004 - 2005 by Jochen Wierum

Option Explicit

' Konstanten
Private Const NIM_ADD = &H0
Private Const NIM_MODIFY = &H1
Private Const NIM_DELETE = &H2
Private Const NIF_MESSAGE = &H1
Private Const NIF_ICON = &H2
Private Const NIF_TIP = &H4

Private Const WM_LBUTTONUP = &H202
Private Const WM_RBUTTONUP = &H205
Private Const WM_LBUTTONDOWN = &H201

' Typen
Private Type NOTIFYICONDATA
    cbSize As Long
    hwnd As Long
    uId As Long
    uFlags As Long
    ucallbackMessage As Long
    hIcon As Long
    szTip As String * 64
End Type

' API-Deklaration
Private Declare Function Shell_NotifyIcon Lib "shell32.dll" Alias _
    "Shell_NotifyIconA" (ByVal dwMessage As Long, _
    lpData As NOTIFYICONDATA) As Long

' Globale Variablen
Private ShellIcon As NOTIFYICONDATA
Private IconActive As Boolean
Public Speaking As Boolean

' Zeigt das TrayIcon an
Public Sub ShowIcon()
    If IconActive Then Exit Sub
    With ShellIcon
        .cbSize = Len(ShellIcon)
        .hIcon = frmHidden.picIcons(0).Picture
        .hwnd = frmHidden.picIcon.hwnd
        .szTip = "Your Wish is My Command!" & Chr(0)
        .ucallbackMessage = WM_LBUTTONDOWN
        .uFlags = NIF_ICON Or NIF_TIP Or NIF_MESSAGE
        .uId = 1&
    End With
    
    Shell_NotifyIcon NIM_ADD, ShellIcon
    IconActive = True
End Sub

' Lscht das TrayIcon
Public Sub HideIcon()
    If Not IconActive Then Exit Sub
    
    Shell_NotifyIcon NIM_DELETE, ShellIcon
    IconActive = False
End Sub

' Frbt das Icon neu ein
Public Function ChangeIcon(NewState As Integer) As Integer
    Static laststate As Integer
    
    If NewState < 0 Or NewState > 2 Or Not IconActive Then Exit Function
    ShellIcon.hIcon = frmHidden.picIcons(NewState).Picture
    Shell_NotifyIcon NIM_MODIFY, ShellIcon
    
    ChangeIcon = laststate
    laststate = NewState
End Function

' Fngt Klicks auf das TrayIcon ab
Public Sub ShellIconClicked(MSG As Integer)
    ' Linksklick entspricht
    ' "stop listening" / "begin listening"
    If MSG = WM_LBUTTONUP Then
        If MayChangeRunning Then
            OnlyOneCommand = Not OnlyOneCommand
            Running = OnlyOneCommand
            ChangeIcon IIf(Running, 2, 0)
        End If
    
    ' Rechtsklick
    ' entspricht "Quit"
    ElseIf MSG = WM_RBUTTONUP Then
        frmHidden.tmrUnload = True
    End If
End Sub

' Spricht einen Text aus
Public Sub Say(text As String)
    Dim oldRunning As Boolean
    Dim oldMayChangeRunning As Boolean
    Dim laststate As Integer
    
    If Len(text) = 0 Then Exit Sub
    
    ' Icon setzen und keine weiteren Befehle abfangen
    ' Wichtig, sonst versteht der PC sich selbst!
    laststate = ChangeIcon(0)
    oldMayChangeRunning = MayChangeRunning
    MayChangeRunning = False
    oldRunning = Running
    Running = False
    
    ' Aussprechen und warten, ist fertig
    frmHidden.TTS.Speak text
    
    Speaking = True
    ' frmHidden.tmrSpeakDebug = True
    Do Until Speaking = False
        DoEvents
    Loop
    ' frmHidden.tmrSpeakDebug = False
    
    ' Nun evtl. wieder zuhren
    ChangeIcon laststate
    Running = oldRunning
    MayChangeRunning = oldMayChangeRunning
End Sub

' Den Benutzer begren
Public Function Welcome() As String
    Dim DayTime As String
    
    Select Case Hour(Now)
    Case 0 To 5, 22 To 24:  DayTime = "night"
    Case 6 To 13:           DayTime = "morning"
    Case 13 To 17:          DayTime = "afternoon"
    Case 18 To 21:          DayTime = "evening"
    End Select
    
    If Month(Now) = bday(0) And Day(Now) = bday(1) Then
        Welcome = "Happy Birthday"
    ElseIf Month(Now) = 12 And Day(Now) = 24 Then
        Welcome = "Merry christmas"
    ElseIf Month(Now) = 1 And Day(Now) = 1 Then
        Welcome = "Happy new Year"
    Else
        Welcome = "Good " & DayTime
    End If
    
    Welcome = SayTime(Now) & " " & Welcome & ", " & Sir & ", how are you doing?"
End Function
