Attribute VB_Name = "modLoadSave"
' (c) 2004 - 2005 by Jochen Wierum

Option Explicit

#Const debugging = False

Public cmds As clsTree

' Schreibt eine Kommand-Datei anhand eines Treeviews
Public Sub SaveCommandsTV(TV As TreeView)
    Dim n As Node
    Dim P As String
    
    On Error GoTo ErrOut
    
    Open APath & "commands.dat" For Output As #1
        ' Jeden Knoten durchgehen
        For Each n In TV.Nodes
            
            ' Systembefehle nicht mitspeichern (Exit Listening, quit, etc.)
            If n.Tag <> "DUMMY" Then
                
                ' Nur die Commands speichern
                If Left(n.Key, 1) = "c" Then
                    ' Parent speichern
                    If n.Parent.text <> P Then
                        P = IIf(n.Parent.Key = "MAIN", "", n.Parent.text)
                    End If
                    
                    ' Daten maskiert ablegen
                    Print #1, Mask(P) & "," & Mask(n.text) & "," & n.Tag
                End If
            End If
        Next n
    Close #1
    
    Set n = Nothing
    
    ' Grammar-Datei schreiben
    CreateGrammarFile
ErrOut:
End Sub

' Ld die Command-Datei in ein Treeview
Public Sub LoadCommandTV(TV As TreeView, CommandCount As Long)
    Dim n As Node
    Dim l As String
    
    With TV.Nodes
        .Clear
        
        ' Systembefehle einfgen
        .Add(, , "MAIN", "Your Wish is My Command", 3).Tag = "DUMMY"
        
        .Add("MAIN", 4, "D1", "admin", 3).Tag = "DUMMY"
        .Add("MAIN", 4, "D2", "begin listening", 3).Tag = "DUMMY"
        .Add("MAIN", 4, "D3", "exit listening", 3).Tag = "DUMMY"
        .Add("MAIN", 4, "D4", "quit", 3).Tag = "DUMMY"
        .Add("MAIN", 4, "D5", "hold", 3).Tag = "DUMMY"
        .Add("MAIN", 4, "D6", "information", 3).Tag = "DUMMY"
        .Add("MAIN", 4, "D7", "debug", 3).Tag = "DUMMY"
    End With
    If Len(Dir(APath & "commands.dat")) = 0 Then Exit Sub
    
    ' Datei lesen
    Open APath & "commands.dat" For Input As #1
        Do Until EOF(1)
            Line Input #1, l
            If Len(l) > 0 Then
                ' Maskierung entfernen und Infos speichern
                Set n = TV.Nodes.Add(FindNodeByKey(UnMaskPop(l), TV, CommandCount), 4, "c" & CommandCount, UnMaskPop(l), 2)
                n.Tag = l
                Set n = Nothing
                
                CommandCount = CommandCount + 1
            End If
        Loop
    Close #1
End Sub

' Sucht einen Knoten anhand des Keys
Private Function FindNodeByKey(ByVal text As String, TV As TreeView, CommandCount As Long) As Node
    Dim n As Node
    
    For Each n In TV.Nodes
        If Len(text) > 0 Then
            If Left(n.Key, 1) = "s" Then
                If n.text = text Then
                    Set FindNodeByKey = n
                    Set n = Nothing
                    Exit Function
                End If
            End If
        Else
            If n.Key = "MAIN" Then
                Set FindNodeByKey = n
                Set n = Nothing
                Exit Function
            End If
        End If
    Next n
    
    ' Im Zweifelsfall den neuen Schlssel anlegen
    Set FindNodeByKey = TV.Nodes.Add("MAIN", 4, "s" & CommandCount, text, 1)
    CommandCount = CommandCount + 1
    Set n = Nothing
End Function

' Push ist einfach Push
Public Sub Push(arr() As String, Value As String)
    If (Len(arr(0)) > 0) Then ReDim Preserve arr(UBound(arr) + 1)
    arr(UBound(arr)) = Value
End Sub

' Popt
Public Function Pop(arr() As String) As String
    Pop = arr(UBound(arr))
    
    If UBound(arr) = 0 Then
        arr(0) = ""
    Else
        ReDim Preserve arr(UBound(arr) - 1)
    End If
End Function

' Maskiert einen Text
Public Function Mask(s As String) As String
    Dim i As Integer
    
    For i = 1 To Len(s)
        If Mid(s, i, 1) = Chr(34) Then Mask = Mask & "\"
        If Mid(s, i, 1) = "\" Then Mask = Mask & "\"
        
        If Mid(s, i, 2) = vbCrLf Then
            Mask = Mask & "\n"
            i = i + 1
        Else
            Mask = Mask & Mid(s, i, 1)
        End If
    Next i
    
    Mask = Chr(34) & Mask & Chr(34)
End Function

' Demaskiert einen Text und lscht den demaskierten Teil
Public Function UnMaskPop(s As String) As String
    Dim i As Integer
    
    UnMaskPop = UnMask(s, 0, i)
    s = Mid(s, i)
End Function

' Demaskiert einen maskierten Teil Text
Public Function UnMask(s As String, Nr As Integer, Optional EndPos As Integer) As String
    Dim i As Integer
    Dim j As Integer
    Dim special As Boolean
    
    For i = 2 To Len(s)
        If Not special And Mid(s, i, 1) = "\" Then
            special = True
        ElseIf special Then
            If Mid(s, i, 1) = "n" Then
                UnMask = UnMask & vbCrLf
            Else
                UnMask = UnMask & Mid(s, i, 1)
            End If
            
            special = False
        Else
            If Not special And Mid(s, i, 1) = Chr(34) Then
                j = j + 1
                i = i + 2 ' (,)
                If Nr + 1 = j Then Exit For
            Else
                If Nr = j Then UnMask = UnMask & Mid(s, i, 1)
            End If
        End If
    Next i
    
    EndPos = i
End Function

' Legt die Grammatikdatei an
Public Sub CreateGrammarFile()
    Dim c() As String
    Dim temp As String
    Dim l As String
    Dim i As Integer
    
    ReDim c(0)
    Push c, "computer"
    Push c, "admin"
    Push c, "begin listening"
    Push c, "exit listening"
    Push c, "quit"
    Push c, "hold"
    Push c, "up"
    Push c, "information"
    Push c, "debug"
    Push c, "i love you"
    
    If Len(Dir(APath & "commands.dat")) > 0 Then
        Open APath & "commands.dat" For Input As #1
            Do Until EOF(1)
                Line Input #1, l
                If Len(l) > 0 Then
                    temp = UnMaskPop(l)
                    SpecialPush temp, c
                    temp = UnMaskPop(l)
                    SpecialPush temp, c
                End If
            Loop
        Close #1
    End If
    
    Open APath & "grammar.dat" For Output As #1
        Print #1, "[Grammer]" & vbCrLf & "LangID = 2057" & vbCrLf & "Type=Cfg" & vbCrLf & "[<Start>]"
        
        For i = 0 To UBound(c)
            If Len(i) > 0 Then Print #1, "<Start>=" & c(i)
        Next i
    Close #1
End Sub

' Pusht ein komplettes Array, als LCase und nur, wenn der Wert nicht schon
' vorhanden ist
Private Sub SpecialPush(text As String, arr() As String)
    If Len(text) = 0 Then Exit Sub
    
    Dim i As Integer
    
    For i = 0 To UBound(arr)
        If arr(i) = LCase(text) Then Exit Sub
    Next i
                    
    Push arr, LCase(text)
End Sub

' Liet die Commanddatei und erstellt daraus einen Zweig aus Tree- und
' Commandklassen
Public Sub LoadCommandClass()
    Dim i As Integer
    Dim l As String
    Dim cmdC As clsCommand
    Dim cmdT As clsTree
    
    If Not cmds Is Nothing Then
        Set cmds = Nothing
    End If
    
    Set cmds = New clsTree
    cmds.SetTreeName "MAIN"
    
    ' Sytemkommandos anlegen
    Dim sysCommand() As String
    sysCommand = Split("computer|admin|begin listening|exit listening|quit|hold|up|information|debug|i love you", "|")
    
    For i = 0 To UBound(sysCommand)
        If i <> 6 And i <> 0 Then
            With cmds.AddCommand(sysCommand(i))
                .AddParam "2"
                .AddParam "3"
                .AddParam CStr(i)
            End With
        End If
    Next i
    
    ' Befehl "computer" gesondert anlegen
    Set cmdComputer = New clsCommand
    With cmdComputer
        .SetCmdName "computer"
        .AddParam "2"
        .AddParam "3"
        .AddParam "0"
    End With
    
    ' Befehl "up" gesondert anlegen
    Set cmdUp = New clsCommand
    With cmdUp
        .SetCmdName "up"
        .AddParam "2"
        .AddParam "3"
        .AddParam "6"
    End With
    
    ' Hier beenden, wenn keine commands definiert sind
    If Len(Dir(APath & "commands.dat")) = 0 Then Exit Sub
    
    ' Datei laden
    Open APath & "commands.dat" For Input As #1
        Do Until EOF(1)
            Line Input #1, l
            If Len(l) > 0 Then
                If Len((UnMask(l, 0))) > 0 Then
                    ' Tree anlegen/finden
                    Set cmdT = cmds.SubTree(UnMaskPop(l))
                Else
                    ' Hauptzweig auswhlen
                    UnMaskPop l
                    Set cmdT = cmds
                End If
                
                ' Command in Tree einbinden
                Set cmdC = cmdT.AddCommand(UnMaskPop(l))
                
                ' Parameter bertragen
                Do Until Len(l) = 0
                    cmdC.AddParam UnMaskPop(l)
                Loop
            End If
        Loop
    Close #1
    
    ' Temporre Objekte entladen
    Set cmdC = Nothing
    Set cmdT = Nothing
    
    ' Evtl Zweig testweise ausgeben
    #If debugging Then
    Test
    #End If
End Sub

#If debugging Then
' Schreibt den Zweig nach C:\test.txt
' 4 debugging only
Public Sub Test()
    Dim trees() As clsTree

    ReDim trees(0)
    Set trees(0) = cmds

    Open "C:\test.txt" For Output As #1
        Test2 trees
    Close #1
End Sub

' Gibt den Inhalt eines Zweigs rekrusiv aus
Public Sub Test2(trees() As clsTree)
    Dim i As Long
    Dim j As Long
    Dim out As String

    Print #1, String(UBound(trees), " ") & "+" & trees(UBound(trees)).GetTreeName

    ' Erst die Commands
    For i = 1 To trees(UBound(trees)).GetCommandCount
        ' Name
        out = String(UBound(trees) + 1, " ")
        out = out & trees(UBound(trees)).GetCommand(i).GetCmdName
        out = out & " ("
        
        ' Parameter
        For j = 0 To trees(UBound(trees)).GetCommand(i).GetParamCount
           out = out & Replace(trees(UBound(trees)).GetCommand(i).GetParam(j) & ", ", vbCrLf, "\n")
        Next j
        out = Left(out, Len(out) - 2) & ")"

        Print #1, out
    Next i

    ' Unterzweige auflisten
    For i = 1 To trees(UBound(trees)).GetSubTreeCount
        ReDim Preserve trees(UBound(trees) + 1)
        Set trees(UBound(trees)) = trees(UBound(trees) - 1).GetSubTree(i)
        Test2 trees
        ReDim Preserve trees(UBound(trees) - 1)
    Next i
End Sub
#End If
