Attribute VB_Name = "modMain"
' (c) 2004 - 2005 by Jochen Wierum

Option Explicit

Private Declare Function GetLocaleInfo Lib "kernel32" Alias "GetLocaleInfoA" ( _
    ByVal Locale As Long, _
    ByVal LCType As Long, _
    ByVal lpLCData As String, _
    ByVal cchData As Long) _
    As Long

' Eine Stimme
Public Type V
    VoiceID As Long
    Name As String
End Type

Public Voices() As V ' - Verfgbare Stimmen
Public Voice As Long ' - Ausgewhlte Simme

Private Const LOCALE_SENGLANGUAGE As Long = &H1001

Public GlobalUnload As Boolean  ' - Alles wird entladen
Public s As clsSettings         ' - Einstellungen

Public APath As String          ' - Anwendungspfad

Public Running As Boolean       ' - Zeigt an, ob das Programm arbeitet
Public MayChangeRunning As Boolean ' - Darf der Programmstatus gendert werden?
Public OnlyOneCommand As Boolean ' - Soll Running nach einem erkannten Wort wieder auf False gesetzt werden?
Public HoldMenu As Boolean      ' - Soll das aktuelle Men nach einem erkannten Wort verlassen werden?
Public Sir As String            ' - Fr weibliche benutzer
Public bday(0 To 1) As Integer  ' - Geburtstag

' Speicher alle verfgbaren Stimmen
Public Sub InitVoices()
    Dim i As Integer
    Dim buffer As String
    
    ReDim Voices(0)
    
    For i = 0 To frmHidden.TTS.CountEngines
        buffer = Space(512)
        
        DoEvents
        
        ' Testen, ob sich der Sprecher berhaupt auswhlen lsse
        On Error Resume Next
        frmHidden.TTS.CurrentMode = i
        On Error GoTo 0
        
        ' Glck gehabt
        If Err.Number = 0 Then
        
            ' Die Sprache ermitteln
            Call GetLocaleInfo(frmHidden.TTS.LanguageID(i), _
                LOCALE_SENGLANGUAGE, buffer, Len(buffer))
            
            ' Wenn alles stimmt, speichern
            If (InStr(buffer, Chr(0))) > 0 Then
                If LCase(Left(buffer, InStr(buffer, Chr(0)) - 1)) = "english" Then
                    Voices(UBound(Voices)).VoiceID = i
                    Voices(UBound(Voices)).Name = frmHidden.TTS.ModeName(i)
                    ReDim Preserve Voices(UBound(Voices) + 1)
                End If
            End If
        Else
            Err.Clear
        End If
    Next i
End Sub

Public Sub Main()
    Dim temp() As String
    
    Set s = New clsSettings
    s.InitialiseINI
    
    APath = App.Path & IIf(Right(App.Path, 1) = "\", "", "\")
    
    'Einstellungen laden
    With frmDebug
        .Show
        .Visible = s.GetSetting("LastPos", "DebugVisible", .Visible)
        .Left = s.GetSetting("LastPos", "DebugLeft", .Left)
        .Top = s.GetSetting("LastPos", "DebugTop", .Top)
    End With
    
    HoldMenu = s.GetSetting("Vars", "HoldMenu", True)
    Voice = s.GetSetting("Vars", "Voice", 0)
    
    Sir = s.GetSetting("Misc", "Sir", "Sir")
    
    On Error Resume Next
    temp = Split(s.GetSetting("Misc", "BDay", "01/18"), "/")
    
    If Err.Number = 0 Then
        bday(0) = Val(temp(0))
        bday(1) = Val(temp(1))
    Else
        bday(0) = -1
        bday(1) = -1
        Err.Clear
    End If
    
    On Error GoTo 0
    
    ' Userinterface initialisieren
    With frmHidden
        .Show
        .Visible = False
        
        ' TrayIcon erstellen
        ShowIcon
        
        ' Sprach Ein- und Ausgabe initialisieren
        InitVoices
        
        If UBound(Voices) = 0 Then
            MsgBox "No english voice was found! Abording."
            MayChangeRunning = True
            .tmrUnload = True
            Exit Sub
        End If
        
        If UBound(Voices) < Voice Then Voice = 0
        .TTS.CurrentMode = Voices(Voice).VoiceID
        
        Say "Please stand by! I'm starting up!"
        
        ' Kommandostruktur laden und in Klassen ablegen
        LoadCommandClass
        
        If (Len(Dir(APath & "grammar.dat"))) = 0 Then
            CreateGrammarFile
        End If
        
        .DSR.GrammarFromFile APath & "grammar.dat"
        .DSR.Activate
    End With
    
    ' Buttondefinitionen laden (Bezeichnungen fr "Ja", "Yes", etc. in
    ' unterschiedlichen Sprachen) und initialisieren
    InitButtons
    
    ' Benutzer begren
    Say Welcome
    
    ' Den aktiven Zweig setzen
    Set ActiveT = cmds
    
    ' Eingaben abfangen, Bereitschaft signalisieren
    MayChangeRunning = True
    Running = True
    ChangeIcon 2
End Sub

Public Sub UnloadAll()
    Dim F As Form
    
    ' Icons entfernen, Objekte entladen
    HideIcon
    Set ActiveT = Nothing
    Set cmds = Nothing
    
    ' Spracherkennung deaktivieren
    frmHidden.DSR.Deactivate
    
    ' Werte speichern
    With frmDebug
        s.SetSetting "LastPos", "DebugLeft", .Left
        s.SetSetting "LastPos", "DebugTop", .Top
        s.SetSetting "LastPos", "DebugVisible", .Visible
    End With
    
    s.SetSetting "Vars", "HoldMenu", HoldMenu
    s.SetSetting "Vars", "Voice", Voice
    
    s.SetSetting "Misc", "BDay", bday(0) & "/" & bday(1)
    s.SetSetting "Misc", "Sir", Sir
    
    ' Alle Objekte entladen
    Set s = Nothing
    GlobalUnload = True
    For Each F In Forms
        Unload F
        Set F = Nothing
    Next F
End Sub
